<?php

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname;
$SERVICE_ROLE = "reseller";
$SERVICE_LANGPREF = "en";

if ($params["DemoMode"]) {
	$SERVICE_URL = "https://api.onlyfordemo.net/anacreon/servlet/APIv3";
} else {
	$SERVICE_URL = "https://soapapi.com/anacreon/servlet/APIv3";
}

require_once (ROOTDIR."/includes/nusoap.php");
require(ROOTDIR."/modules/registrars/directi/lib/apiutil.php");

function uk2_GetConfigArray() {

$configarray = array(
 "Username" => array( "Type" => "text", "Size" => "30", "Description" => "Your registered email address", ),
 "Password" => array( "Type" => "password", "Size" => "20", "Description" => "Your account password", ),
 "ParentID" => array( "Type" => "text", "Size" => "10", "Description" => "From the control panel, go to Settings > Personal Information > Primary Profile", ),
 "DemoMode" => array( "Type" => "yesno", ),
);

return $configarray;

}

function uk2_GetNameservers($params) {
    global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
    $SERVICE_USERNAME = $params["Username"];
    $SERVICE_PASSWORD = $params["Password"];
    $SERVICE_PARENTID = $params["ParentID"];
    $customerid = $params["CustomerID"];
    $domainname = $params["sld"] . "." . $params["tld"];
    $result = uk2_getorderid($domainname);
    $orderid = $result["orderid"];
    if ($orderid) {
        $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
        $callfunction = "getDetails";
        $option = getVectorFromString(array("All"));
        $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
        $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
        if ($lbresponse["fault"]) {
        	$result["error"] = "An unknown fault occured - please contact support";
        } elseif ($lbresponse["error"]) {
        	$result["error"] = $lbresponse["error"];
        } else {
        	$result["ns1"] = $lbresponse["result"]["ns1"];
        	$result["ns2"] = $lbresponse["result"]["ns2"];
        	$result["ns3"] = $lbresponse["result"]["ns3"];
        	$result["ns4"] = $lbresponse["result"]["ns4"];
        }
    }
    return $result;
}

function uk2_SaveNameservers($params) {
    global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
    $SERVICE_USERNAME = $params["Username"];
    $SERVICE_PASSWORD = $params["Password"];
    $SERVICE_PARENTID = $params["ParentID"];
    $customerid = $params["CustomerID"];
    $domainname = $params["sld"] . "." . $params["tld"];
    $result = uk2_getorderid($domainname);
    $orderid = $result["orderid"];
    if ($orderid) {
        $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
        $callfunction = "modifyNameServer";
        $nameserverarray[] = "ns1->".$params["ns1"];
        $nameserverarray[] = "ns2->".$params["ns2"];
        if ($params["ns3"]) { $nameserverarray[] = "ns3->".$params["ns3"]; }
        if ($params["ns4"]) { $nameserverarray[] = "ns4->".$params["ns4"]; }
        $nameservers = getHashFromString($nameserverarray);
        $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $nameservers);
        $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
        if ($lbresponse["fault"]) {
        	$result["error"] = "An unknown fault occured - please contact support";
        } elseif ($lbresponse["error"]) {
        	$result["error"] = $lbresponse["error"];
        }
    }
    return $result;
}

function uk2_GetRegistrarLock($params) {
    global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
    $SERVICE_USERNAME = $params["Username"];
    $SERVICE_PASSWORD = $params["Password"];
    $SERVICE_PARENTID = $params["ParentID"];
    $customerid = $params["CustomerID"];
    $domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Order.wsdl";
	$callfunction = "getLockList";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid);
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	if ($lbresponse["result"]["transferlock"]) {
		$lockstatus="locked";
	} else {
		$lockstatus="unlocked";
	}
	return $lockstatus;
}

function uk2_SaveRegistrarLock($params) {
    global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
    $SERVICE_USERNAME = $params["Username"];
    $SERVICE_PASSWORD = $params["Password"];
    $SERVICE_PARENTID = $params["ParentID"];
    $customerid = $params["CustomerID"];
    $domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Order.wsdl";
	if ($params["lockenabled"]=="locked") {
		$callfunction="setCustomerLock";
	} else {
		$callfunction="removeCustomerLock";
	}
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid);
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	return $values;
}


function uk2_RegisterDomain($params) {

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
$SERVICE_USERNAME = $params["Username"];
$SERVICE_PASSWORD = $params["Password"];
$SERVICE_PARENTID = $params["ParentID"];
$customerid = $params["CustomerID"];
$domainname = $params["sld"] . "." . $params["tld"];

$password = genLBRandomPW();

$name = $params["firstname"]." ".$params["lastname"];
$companyname = $params["companyname"];
$email = $params["email"];
$address1 = $params["address1"];
$address2 = $params["address2"];
$city = $params["city"];
$state = $params["state"];
$postcode = $params["postcode"];
$country = $params["country"];
$phonenumber = $params["phonenumber"];
$phonenumber = preg_replace('/[^0-9]/','',$phonenumber);
require(ROOTDIR."/includes/countriescallingcodes.php");
$countrycode = $params["country"];
$countrycode = $countrycallingcodes[$countrycode];
if (!$companyname) { $companyname="None"; }

    $result = select_query("tbldomains","tblclients.email",array("domain"=>$domainname),"","","","tblclients ON tblclients.id=tbldomains.userid");
	$data = mysql_fetch_array($result);
	$email = $data["email"];
	$result = "";
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Customer.wsdl";
	$callfunction = "getCustomerId";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $email);
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	if ($lbresponse["fault"]) {
		# Fault
		$result["error"] = "An unknown fault occured - please contact support";
	} elseif ($lbresponse["error"]) {
		# Error
		$result["error"] = $lbresponse["error"];
	} else {
		# Successful
		$customerid = $lbresponse["result"];
	}

if ($result["error"]) {
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Customer.wsdl";
	$callfunction = "signUp";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $email,$password,$name,$companyname,$address1,$address2,"",$city,$state,$country,$postcode,$countrycode,$phonenumber,"","","","","en","","");
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	if ($lbresponse["error"]) {
		# Error
		$result["error"] = $lbresponse["error"];
		return $result;
	} else {
		# Successful
		$customerid = $lbresponse["result"];
		$result="";
	}
}

# Set contact type for UK
if (preg_match('/uk$/i', $params["tld"])) {
	$contacttype = "UkContact";
} elseif (preg_match('/eu$/i', $params["tld"])) {
	$contacttype = "EuContact";
} else {
	$contacttype = "Contact";
}

# Look for existing contact
$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
$callfunction = "listByType";
$emailAddr = $email;
$numOfRecordPerPage = 10;
$pageNum = 1;
$type = $contacttype;
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $customerid, $contactId, $currentStatus, $creationDTRangStart, $creationDTRangEnd, $contactName, $companyName, $emailAddr, $numOfRecordPerPage, $pageNum, $orderBy, $type, $requirements);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	if ($lbresponse["result"]["result"]) {
		$contactid = $lbresponse["result"]["result"][0]["contact.contactid"];
	}
}

if ($contactid=="") {

# Create Contact
$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
$callfunction = "addContact";
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $name, $companyname, $email, $address1, $address2, "", $city, $state, $country, $postcode, $countrycode, $phonenumber, "", "", $customerid, $contacttype, $extraInfo);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$contactid = $lbresponse["result"];
}

}

if ($result["error"]) {
	return $result;
}

# Check for Contact ID
if (!$contactid) {
	$result["error"] = "An Unknown Error Occured while Creating Contact";
	return $result;
}

if (preg_match('/us$/i',$params["tld"])) {
	$purpose = $params["additionalfields"]['Application Purpose'];
    $category = $params["additionalfields"]['Nexus Category'];
	if ($purpose=="Business use for profit") {
		$purpose="P1";
	} elseif (($purpose=="Non-profit business")OR($purpose=="Club")OR($purpose=="Association")OR($purpose=="Religious Organization")) {
		$purpose="P2";
	} elseif ($purpose=="Personal Use") {
		$purpose="P3";
	} elseif ($purpose=="Educational purposes") {
		$purpose="P4";
	} elseif ($purpose=="Government purposes") {
		$purpose="P5";
	}
    $contactDetailsHash = array("purpose"=>$purpose,"category"=>$category);
    $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContactExt.wsdl";
    $callfunction = "setContactDetails";
    $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $contactid, $contactDetailsHash, "domus");
    $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
}

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "registerDomain";
$nameServersList[]=$params["ns1"];
$nameServersList[]=$params["ns2"];
if ($params["ns3"]) { $nameServersList[]=$params["ns3"]; }
if ($params["ns4"]) { $nameServersList[]=$params["ns4"]; }
$domainhash=array($domainname=>$params["regperiod"]);
if ((preg_match('/uk$/i', $params["tld"]))OR(preg_match('/eu$/i', $params["tld"]))) {
	$contacthash=array('registrantcontactid'=>$contactid);
} else {
	$contacthash=array('registrantcontactid'=>$contactid,'admincontactid'=>$contactid,'technicalcontactid'=>$contactid,'billingcontactid'=>$contactid);
}
$temp['domainhash']=$domainhash;
$temp['contacthash']=$contacthash;
$addParamList[] = $temp;
$customerId = $customerid;
$invoiceOption = 'NoInvoice'; //or it can be PayInvoice, KeepInvoice, OnlyAdd
if ($params["idprotection"]) {
	$enablePrivacyProtection = true;
} else {
	$enablePrivacyProtection = false;
}
$validate = false; // or true;
$extraInfo = array(); //send extra info if required
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $addParamList, $nameServersList, $customerId, $invoiceOption, $enablePrivacyProtection, $validate, $extraInfo);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$error = $lbresponse["result"][$domainname]["error"];
	if ($error) {
		$result["error"] = "Domain Registration Error - $error";
		return $result;
	}
    $realstatus = $lbresponse["result"][$domainname]["status"];
    $actionstatus = $lbresponse["result"][$domainname]["actionstatusdesc"];
    if ($realstatus != "Success") {
		$result["error"] = "Action Status - $actionstatus";
		return $result;
	}
}

return $result;

}

function uk2_TransferDomain($params) {

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
$SERVICE_USERNAME = $params["Username"];
$SERVICE_PASSWORD = $params["Password"];
$SERVICE_PARENTID = $params["ParentID"];
$customerid = $params["CustomerID"];
$domainname = $params["sld"] . "." . $params["tld"];

$password = genLBRandomPW();

$name = $params["firstname"]." ".$params["lastname"];
$companyname = $params["companyname"];
$email = $params["email"];
$address1 = $params["address1"];
$address2 = $params["address2"];
$city = $params["city"];
$state = $params["state"];
$postcode = $params["postcode"];
$country = $params["country"];
$phonenumber = $params["phonenumber"];
$phonenumber = preg_replace('/[^0-9]/','',$phonenumber);
require(ROOTDIR."/includes/countriescallingcodes.php");
$countrycode = $params["country"];
$countrycode = $countrycallingcodes[$countrycode];
if (!$companyname) { $companyname="None"; }

    $result = select_query("tbldomains","tblclients.email",array("domain"=>$domainname),"","","","tblclients ON tblclients.id=tbldomains.userid");
	$data = mysql_fetch_array($result);
	$email = $data["email"];
	$result = "";
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Customer.wsdl";
	$callfunction = "getCustomerId";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $email);
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	if ($lbresponse["fault"]) {
		# Fault
		$result["error"] = "An unknown fault occured - please contact support";
	} elseif ($lbresponse["error"]) {
		# Error
		$result["error"] = $lbresponse["error"];
	} else {
		# Successful
		$customerid = $lbresponse["result"];
	}

if ($result["error"]) {
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/Customer.wsdl";
	$callfunction = "signUp";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $email,$password,$name,$companyname,$address1,$address2,"",$city,$state,$country,$postcode,$countrycode,$phonenumber,"","","","","en","","");
	$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
	if ($lbresponse["error"]) {
		# Error
		$result["error"] = $lbresponse["error"];
		return $result;
	} else {
		# Successful
		$customerid = $lbresponse["result"];
		$result="";
	}
}

# Set contact type for UK
if (preg_match('/uk$/i', $params["tld"])) {
	$contacttype = "UkContact";
} elseif (preg_match('/eu$/i', $params["tld"])) {
	$contacttype = "EuContact";
} else {
	$contacttype = "Contact";
}

# Look for existing contact
$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
$callfunction = "listByType";
$emailAddr = $email;
$numOfRecordPerPage = 10;
$pageNum = 1;
$type = $contacttype;
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $customerid, $contactId, $currentStatus, $creationDTRangStart, $creationDTRangEnd, $contactName, $companyName, $emailAddr, $numOfRecordPerPage, $pageNum, $orderBy, $type, $requirements);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	if ($lbresponse["result"]["result"]) {
		$contactid = $lbresponse["result"]["result"][0]["contact.contactid"];
	}
}

if ($contactid=="") {

    # Create Contact
    $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
    $callfunction = "addContact";
    $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $name, $companyname, $email, $address1, $address2, "", $city, $state, $country, $postcode, "00", $phonenumber, "", "", $customerid, $contacttype, "");
    $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
    if ($lbresponse["fault"]) {
    	# Fault
    	$result["error"] = "An unknown fault occured - please contact support";
    } elseif ($lbresponse["error"]) {
    	# Error
    	$result["error"] = $lbresponse["error"];
    } else {
    	# Successful
    	$contactid = $lbresponse["result"];
    }

}

# Check for Contact ID
if (!$contactid) {
	if (!$result["error"]) {
		$result["error"] = "An Unknown Error Occured while Creating Contact";
	}
	return $result;
}

if (preg_match('/us$/i',$params["tld"])) {
	$purpose = $params["additionalfields"]['Application Purpose'];
    $category = $params["additionalfields"]['Nexus Category'];
	if ($purpose=="Business use for profit") {
		$purpose="P1";
	} elseif (($purpose=="Non-profit business")OR($purpose=="Club")OR($purpose=="Association")OR($purpose=="Religious Organization")) {
		$purpose="P2";
	} elseif ($purpose=="Personal Use") {
		$purpose="P3";
	} elseif ($purpose=="Educational purposes") {
		$purpose="P4";
	} elseif ($purpose=="Government purposes") {
		$purpose="P5";
	}
    $contactDetailsHash = array("purpose"=>$purpose,"category"=>$category);
    $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContactExt.wsdl";
    $callfunction = "setContactDetails";
    $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $contactid, $contactDetailsHash, "domus");
    $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
}

if (preg_match('/eu$/i',$params["tld"])) {

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DotEu.wsdl";
$callfunction = "transfer";
$invoiceOption = 'NoInvoice'; //or it can be PayInvoice, KeepInvoice, OnlyAdd
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $domainname, $customerId, '', '', $invoiceOption);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$error = $lbresponse["result"][$domainname]["error"];
	if ($error) {
		$result["error"] = "Domain Registration Error - $error";
		return $result;
	}
	$realstatus = $lbresponse["result"][$domainname]["status"];
    $actionstatus = $lbresponse["result"][$domainname]["actionstatusdesc"];
    if ($realstatus != "Success") {
		$result["error"] = "Action Status - $actionstatus";
		return $result;
	}
}

} else {

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "addTransferDomain";
$nameServersList[]=$params["ns1"];
$nameServersList[]=$params["ns2"];
if ($params["ns3"]) { $nameServersList[]=$params["ns3"]; }
if ($params["ns4"]) { $nameServersList[]=$params["ns4"]; }
$domainhash=array($domainname=>$params["transfersecret"]);
if ((preg_match('/uk$/i', $params["tld"]))OR(preg_match('/eu$/i', $params["tld"]))) {
	$contacthash=array('registrantcontactid'=>$contactid);
} else {
	$contacthash=array('registrantcontactid'=>$contactid,'admincontactid'=>$contactid,'technicalcontactid'=>$contactid,'billingcontactid'=>$contactid);
}
$temp['domainhash']=$domainhash;
$temp['contacthash']=$contacthash;
$addParamList[] = $temp;
$customerId = $customerid;
$invoiceOption = 'NoInvoice'; //or it can be PayInvoice, KeepInvoice, OnlyAdd
if ($params["idprotection"]) {
	$enablePrivacyProtection = true;
} else {
	$enablePrivacyProtection = false;
}
$validate = false; // or true;
$extraInfo = array(); //send extra info if required
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $addParamList, $nameServersList, $customerId, $invoiceOption, $enablePrivacyProtection, $validate, $extraInfo);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$error = $lbresponse["result"][$domainname]["error"];
	if ($error) {
		$result["error"] = "Domain Registration Error - $error";
		return $result;
	}
	$realstatus = $lbresponse["result"][$domainname]["status"];
    $actionstatus = $lbresponse["result"][$domainname]["actionstatusdesc"];
    if ($realstatus != "Success") {
    #if (($actionstatus!="Domain registration completed Successfully")AND($actionstatus!="Transfer waiting for Admin Contact Approval")) {
		$result["error"] = "Action Status - $actionstatus";
		return $result;
	}
}

}

return $result;

}

function uk2_RenewDomain($params) {

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
$SERVICE_USERNAME = $params["Username"];
$SERVICE_PASSWORD = $params["Password"];
$SERVICE_PARENTID = $params["ParentID"];
$customerid = $params["CustomerID"];
$domainname = $params["sld"] . "." . $params["tld"];

$result = uk2_getorderid($domainname);
$orderid = $result["orderid"];

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "getDetails";
$option = getVectorFromString(array("All"));
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$data = $lbresponse["result"];
}

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "renewDomain";
$domainHash[$domainname] = array("entityid"=>$data["entityid"],"noofyears"=>$params["regperiod"],"expirydate"=>$data["endtime"]);
$invoiceOption = "NoInvoice";
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $domainHash, $invoiceOption);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
}

return $result;

}

function uk2_GetContactDetails($params) {

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
$SERVICE_USERNAME = $params["Username"];
$SERVICE_PASSWORD = $params["Password"];
$SERVICE_PARENTID = $params["ParentID"];
$customerid = $params["CustomerID"];
$domainname = $params["sld"] . "." . $params["tld"];

$result = uk2_getorderid($domainname);
$orderid = $result["orderid"];

if ($orderid) {

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "getDetails";
$option = getVectorFromString(array("All"));
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$contactid = $lbresponse["result"]["registrantcontactid"];
    $result = array();
    $result["Registrant"]["Name"] = $lbresponse["result"]["registrantcontact"]["name"];
	$result["Registrant"]["Company Name"] = $lbresponse["result"]["registrantcontact"]["company"];
	$result["Registrant"]["Email Address"] = $lbresponse["result"]["registrantcontact"]["emailaddr"];
	$result["Registrant"]["Address 1"] = $lbresponse["result"]["registrantcontact"]["address1"];
	$result["Registrant"]["Address 2"] = $lbresponse["result"]["registrantcontact"]["address2"];
	$result["Registrant"]["City"] = $lbresponse["result"]["registrantcontact"]["city"];
	$result["Registrant"]["State"] = $lbresponse["result"]["registrantcontact"]["state"];
	$result["Registrant"]["Zip"] = $lbresponse["result"]["registrantcontact"]["zip"];
	$result["Registrant"]["Country"] = $lbresponse["result"]["registrantcontact"]["country"];
	$result["Registrant"]["Telephone Number CC"] = $lbresponse["result"]["registrantcontact"]["telnocc"];
	$result["Registrant"]["Telephone Number"] = $lbresponse["result"]["registrantcontact"]["telno"];
	$result["Registrant"]["Fax Number CC"] = $lbresponse["result"]["registrantcontact"]["faxnocc"];
	$result["Registrant"]["Fax Number"] = $lbresponse["result"]["registrantcontact"]["faxno"];
}

/*
$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
$callfunction = "getDetails";
$option = getVectorFromString(array("All"));
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $contactid, $option);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$out = $lbresponse["result"];
	unset($result["orderid"]);

}
*/

return $result;

}

}

function uk2_SaveContactDetails($params) {

global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
$SERVICE_USERNAME = $params["Username"];
$SERVICE_PASSWORD = $params["Password"];
$SERVICE_PARENTID = $params["ParentID"];
$customerid = $params["CustomerID"];
$domainname = $params["sld"] . "." . $params["tld"];

$result = uk2_getorderid($domainname);
$orderid = $result["orderid"];

if ($orderid) {

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
$callfunction = "getDetails";
$option = getVectorFromString(array("All"));
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
	$contactid = $lbresponse["result"]["registrantcontactid"];
}

$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomContact.wsdl";
$callfunction = "mod";
$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $contactid, $params["contactdetails"]["Registrant"]["Name"], $params["contactdetails"]["Registrant"]["Company Name"], $params["contactdetails"]["Registrant"]["Email Address"], $params["contactdetails"]["Registrant"]["Address 1"], $params["contactdetails"]["Registrant"]["Address 2"], "", $params["contactdetails"]["Registrant"]["City"], $params["contactdetails"]["Registrant"]["State"], $params["contactdetails"]["Registrant"]["Country"], $params["contactdetails"]["Registrant"]["Zip"], $params["contactdetails"]["Registrant"]["Telephone Number CC"], $params["contactdetails"]["Registrant"]["Telephone Number"], $params["contactdetails"]["Registrant"]["Fax Number CC"], $params["contactdetails"]["Registrant"]["Fax Number"]);
$lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
if ($lbresponse["fault"]) {
	# Fault
	$result["error"] = "An unknown fault occured - please contact support";
} elseif ($lbresponse["error"]) {
	# Error
	$result["error"] = $lbresponse["error"];
} else {
	# Successful
}

}

return $result;

}

function uk2_RegisterNameserver($params) {
	global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
	$SERVICE_USERNAME = $params["Username"];
	$SERVICE_PASSWORD = $params["Password"];
	$SERVICE_PARENTID = $params["ParentID"];
	$customerid = $params["CustomerID"];
	$domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
	$callfunction = "addChildNameServer";
    $ipaddress = getVectorFromString(array($params["ipaddress"]));
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $params["nameserver"], $ipaddress);
	$lbresponse = uk2_docall($wsdlFileName, $callfunction, $parameters);
    if ($lbresponse["error"]) {
        $values["error"] = $lbresponse["error"];
    }
    return $values;
}

function uk2_ModifyNameserver($params) {

	global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
	$SERVICE_USERNAME = $params["Username"];
	$SERVICE_PASSWORD = $params["Password"];
	$SERVICE_PARENTID = $params["ParentID"];
	$customerid = $params["CustomerID"];
	$domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
	$callfunction = "modifyChildNameServerIp";
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $params["nameserver"], $params["currentipaddress"], $params["newipaddress"]);
	$lbresponse = uk2_docall($wsdlFileName, $callfunction, $parameters);
    if ($lbresponse["error"]) {
        $values["error"] = $lbresponse["error"];
    }
    return $values;

}

function uk2_DeleteNameserver($params) {
	global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
	$SERVICE_USERNAME = $params["Username"];
	$SERVICE_PASSWORD = $params["Password"];
	$SERVICE_PARENTID = $params["ParentID"];
	$customerid = $params["CustomerID"];
	$domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
	$callfunction = "deleteChildNameServerIp";
    $ipaddress = gethostbyname($params["nameserver"]);
	$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $params["nameserver"], $ipaddress);
	$lbresponse = uk2_docall($wsdlFileName, $callfunction, $parameters);
    if ($lbresponse["error"]) {
        $values["error"] = $lbresponse["error"];
    }
    return $values;
}

function uk2_GetEPPCode($params) {
	global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
	$SERVICE_USERNAME = $params["Username"];
	$SERVICE_PASSWORD = $params["Password"];
	$SERVICE_PARENTID = $params["ParentID"];
	$customerid = $params["CustomerID"];
	$domainname = $params["sld"] . "." . $params["tld"];
	$result = uk2_getorderid($domainname);
	$orderid = $result["orderid"];
	if ($orderid) {
		$wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
		$callfunction = "getDetails";
		$option = getVectorFromString(array("OrderDetails"));
		$parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
		$lbresponse = uk2_docall($wsdlFileName, $callfunction, $parameters);
		if ($lbresponse["fault"]) {
			$result["error"] = "An unknown fault occured - please contact support";
		}
		elseif ($lbresponse["error"]) {
			$result["error"] = $lbresponse["error"];
		}
		else {
			$result["eppcode"] = $lbresponse["result"]["domsecret"];
		}
	}
	return $result;
}

# --------------------------------

function uk2_docall($wsdlFileName,$callfunction,$parameters) {
global $debug_output;

$directi = new nusoap_client($wsdlFileName,"wsdl");

$result = $directi->call($callfunction,$parameters);
$err = $directi->getError();

if ($debug_output) {
echo "<textarea cols=120 rows=10>Call Function: $callfunction\n\n";
echo "Parameters: \n";
print_r($parameters);
echo "\n\n";
if ($directi->fault) {
    echo "Fault:\n";
	print_r($result);
	echo "\n\n";
} else {
    if ($err) {
        echo "Error:\n" . $err . "\n\n";
    } else {
        echo "Result:\n";
		print_r($result);
		echo "\n\n";
    }
}
echo "Request:\n" . htmlspecialchars($directi->request, ENT_QUOTES) . "\n\n";
echo "Response:\n" . htmlspecialchars($directi->response, ENT_QUOTES) . "\n\n";
#echo "Debug:\n" . htmlspecialchars($directi->debug_str, ENT_QUOTES) . "\n\n";
echo "</textarea>";
}

if ($directi->fault) {
	# Fault
	$returnresult["fault"] = $result;
	$tempfaultstring = explode("#~#",$returnresult["fault"]["faultstring"]);
	$err = $tempfaultstring[2];
	if ($err=="NullPointerException") {
		$err = "Invalid Data Rejected";
	}
	if ($err) {
		$returnresult["fault"] = "";
		$returnresult["error"] = $err;
	}
} else {
    if ($err) {
		# Error
        $returnresult["error"] = $err;
    } else {
		# Success
		$returnresult["result"] = $result;
    }
}
return $returnresult;

}

function uk2_getorderid($domainname) {
    global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $debug_output;
    $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
    $callfunction = "getOrderIdByDomain";
    $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $domainname, "domcno");
    $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
    if ($lbresponse["fault"]) {
    	$result["error"] = "An unknown fault occured - please contact support";
    } elseif ($lbresponse["error"]) {
    	$result["error"] = $lbresponse["error"];
    } else {
    	$result["orderid"] = $lbresponse["result"];
    }
    return $result;
}

function uk2_getcustomerid($domainname) {
	global $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_PARENTID, $customerid, $domainname, $orderid, $debug_output;
    $wsdlFileName = ROOTDIR."/modules/registrars/directi/lib/wsdl/DomOrder.wsdl";
    $callfunction = "getDetails";
    $option = getVectorFromString(array("All"));
    $parameters = array($SERVICE_USERNAME, $SERVICE_PASSWORD, $SERVICE_ROLE, $SERVICE_LANGPREF, $SERVICE_PARENTID, $orderid, $option);
    $lbresponse = uk2_docall($wsdlFileName,$callfunction,$parameters);
    if ($lbresponse["fault"]) {
    	$result["error"] = "An unknown fault occured - please contact support";
    } elseif ($lbresponse["error"]) {
    	$result["error"] = $lbresponse["error"];
    } else {
    	$customerid = $lbresponse["result"]["customerid"];
    }
	return $customerid;
}

?>